package my.expression.functions;

import org.eclipse.birt.core.exception.BirtException;
import org.eclipse.birt.core.script.functionservice.IScriptFunctionContext;
import org.eclipse.birt.core.script.functionservice.IScriptFunctionExecutor;
import org.apache.commons.lang.WordUtils; 

public class StringHelperScriptExecutor implements IScriptFunctionExecutor 
{
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	private IScriptFunctionExecutor executor;
	
	public StringHelperScriptExecutor(String functionName) 
		throws BirtException
	{
		if ("Abbreviate".equals(functionName))
		{
			this.executor = new Abbreviate();
		}
		else
			throw new BirtException( "my.testing.functions",
					null,
					"invalid.function.name"	+ "StringHelper." + functionName );
		
	}

	private class Abbreviate implements IScriptFunctionExecutor
	{
		public Abbreviate() 
		{
		}
		/**
		 * 
		 */
		private static final long serialVersionUID = 1L;

		public Object execute(Object[] args, IScriptFunctionContext context)
				throws BirtException 
		{
			if ( args == null  )
				throw new IllegalArgumentException( "The number of arguement is incorrect." );
			if( args[0] == null)
			{
				return null;
			}
			else
			{	
				int lower = 0;
				int upper = 0;
				if( args[1] instanceof Double ){
					lower = ((Double)args[1]).intValue();
				}else if( args[1] instanceof String){
					lower = Integer.parseInt((String)args[1]);
				}else if( args[1] instanceof Integer){
					lower = ((Integer)args[1]).intValue();				
				}else{
					lower = 3;
				}
				if( args[2] instanceof Double ){
					upper = ((Double)args[2]).intValue();
				}else if( args[2] instanceof String){
					upper = Integer.parseInt((String)args[2]);
				}else if( args[2] instanceof Integer){
					upper = ((Integer)args[2]).intValue();				
				}else{
					upper = 5;
				}
				return WordUtils.abbreviate((String)args[0], lower, upper, (String)args[3]);
			}
		}
		
	}

	
	public Object execute(Object[] arg0, IScriptFunctionContext arg1)
			throws BirtException 
	{
		return this.executor.execute(arg0, arg1);
	}

}
