package org.eclipse.birt.aggregate.previousvalue;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.eclipse.birt.data.engine.api.aggregation.IAggrFunction;
import org.eclipse.birt.data.engine.api.aggregation.IAggregationFactory;
/**
 * 
 */
public class PVAggregationFactory implements IAggregationFactory
{
	private Map aggrMap = new HashMap( );
	private List aggregations = new ArrayList( );
	/**
	 * 
	 */
	private void populateAggregations( )
	{
		final PrevVal prevval = new PrevVal( );
		aggrMap.put( "PREVVAL", prevval );
		aggregations.add( prevval );

	}
	/**
	 * 
	 */
	public PVAggregationFactory( )
	{
		populateAggregations( );
	}
	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.birt.data.engine.api.aggregation.IAggregationFactory#getAggregations()
	 */
	public List getAggregations( )
	{
		return aggregations;
	}
	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.birt.data.engine.api.aggregation.IAggregationFactory#getAggregation(java.lang.String)
	 */
	public IAggrFunction getAggregation( String name )
	{
		return (IAggrFunction) aggrMap.get( name.toUpperCase( ) );
	}
}
